;#*********************************************************************#
;*                                                                     *
;*                 PB-Intro by Epyx / Epyx_FXLib v1.1                  *
;*                                                                     *
;*  This Intro uses two UserLibs...                                    *
;*  http://www.purearea.net/pb/download/userlibs/EP_FXLib.zip          *                             *
;*  http://www.purearea.net/pb/download/userlibs/minifmod170_pb.zip    *
;#*********************************************************************#

InitSprite()
InitSprite3D() ; Importand to Init Sprite3D for this Effect
InitKeyboard()
EP_InitFXLib() ;Init the whole LIB


    
    
OpenScreen(640,480,32,"PB intro")
UsePNGImageDecoder()


#pi = 3.1415

EP_SetScrollText(0, "                          Welcome to a new intro written by epyx using Pure Basic                                                                            ") 
EP_SetScrollText(1, "Hi this is Epyx writing, this is a little example intro written by me, this fabulous Tune was composed by quazar of sanxion. the whole intro was written using Pure Basic and my FX-Lib you can get the Lib on Pure-Area. version 1.2 will coming soon,  Greetings to all from the german and english Board. I dont know what can i write further bye and enjoy the show") 


CatchSprite(10, ?Pic_Pure, #PB_Sprite_Texture) : CreateSprite3D(10,10)
CatchSprite(11, ?Pic_Basic,#PB_Sprite_Texture) : CreateSprite3D(11,11)
CatchSprite(12, ?Pic_Ship, #PB_Sprite_Texture) : CreateSprite3D(12,12)


EP_CatchStarSprite(1, ?Pic_Blob) 
EP_Init2DStars(200, 3, 0.5) 
EP_2DStarsDegree(540) 


 ; Init a Fading Screen with White Color and Speed 2.5
 EP_InitFading(RGB(0,0,0), 5.5)

EP_CatchFont32(1, ?Font_Hole) 
EP_Create32Scroll(1, 0, 1, 410) 
EP_SetSinScroll32(1, 4, 4, 40, 2) 
EP_SetScroll32Speed(1, 2) 


 ; First clear the Screen with white color and wait
 ClearScreen(0,0,0) : FlipBuffers()

 
 
 ; check the FrameRate, an set FrameRate if to fast
 StartTime = ElapsedMilliseconds()             ; ermittelt den aktuellen Wert
 Repeat
   ClearScreen(0,0,0)
   fpx = EP_FPS() 
   If fpx>90 : SetFrameRate(85) : EndIf
   TiM = ElapsedMilliseconds()-StartTime

   FlipBuffers() 
 Until Tim>2000
 
 
 
 
 ; We Say the Screen is Fadet out,
 EP_SetFadeState(2)
 IncludeFile "musinc.pbi"
 
 
 ; Start Music
 FSOUND_File_SetCallbacks(@modopenmem(), @modclosemem(), @modreadmem(), @modseekmem(), @modtellmem())
 mod = FMUSIC_LoadSong("quazar-funky_stars.xm", #Null)
 If mod<>0 : FMUSIC_PlaySong(mod) : EndIf
 
 
 
 Ende=0
 Totti=0
 Logo_X = 660
 Dim XAxis(650)
 shp=496 : wave.f = 20

; ######### Part 1 ###############

Repeat
  fpx = EP_FPS() 
  If fpx>85 : SetFrameRate(85) : EndIf
  Morder = FMUSIC_GetOrder(mod)
  Mrow   = FMUSIC_GetRow(mod)
  If (Morder<=2) Or (Morder<=2 And Mrow<60) 
    ClearScreen(250,200,150)
    If Wave<XWave : Wave+0.5 : EndIf 
    StartDrawing(ScreenOutput()) 
    For t = 0 To 640
      XAxis(t) = Sin(Totti * (#pi/360))*wave  : Totti+1
      LineXY(t, 240+(XAxis(t)),t, 480, RGB(230,180,100)) 
    Next t : Totti-637
    StopDrawing() 
    EP_2DSpritesDraw(1)  
 
    Start3D()
      RotateSprite3D(12, (XAxis(shp)/2), 0)
      DisplaySprite3D(12,270,178+XAxis(300), 255)
      ZoomSprite3D(10, 512, 512) : DisplaySprite3D(10,Logo_X, 10, 20)
      ZoomSprite3D(11, 512, 512) : DisplaySprite3D(11,(Logo_X+560),10, 20)
    Stop3D()
 
    EP_Move32Scroll(1) : Logo_X-1  : EP_FadeScreen(0)  
    EndIf 
 
    If Morder=1 : XWave=130 : EndIf 
    If Morder=2 And Mrow = 60 : EP_SetFadeColor(RGB(255,255,255)) : EP_SetFadeState(2) : ClearScreen(255,255,255) : EndIf 
    If Morder=2 And Mrow > 60 : EP_SetFadeSpeed(1.5)  : ClearScreen(255,255,255) : Ende=1 : EndIf 

    ExamineKeyboard()
    If KeyboardReleased(#PB_Key_Escape) : End : EndIf

  FlipBuffers()
Until Ende<>0

EP_Close32Scroll(1) 
EP_FreeFont32(1) 
EP_closeStarSprite(1) 








; ######### Part 2 ###############


  
 EP_CatchVectorObject(?Cube1, ?Cube2)
 EP_SetVectorXRotation(0.5)
 EP_SetVectorYRotation(1.5)
 EP_SetVectorZRotation(1)

 ; And a cool Fly around the Screen
 EP_SetVectorYFly(20, 2)
 EP_SetVectorXFly(250, 1)
 EP_SetVectorZFly(100, 2)
 
 
 EP_CatchBallObject(?UFO1, ?UFO2)
 EP_SetBallZPos(300)

 ; Rotate the Object
 EP_SetBallXRotation(0.3)
 EP_SetBallYRotation(1.5)
 EP_SetBallZRotation(0.7)
 
 EP_Init2DStars(100,3,0.5,0,0,640,80)

 EP_SetGradientTable(0, 100, RGB(0,0,40), RGB(0,0,0)) 
 EP_SetGradientTable(221, 320, RGB(0,0,0), RGB(0,0,40)) 
 EP_CreateRasterBar(10, 0, 320) 
 
 CatchSprite(10, ?Pic_Logo, 0) 
 EP_CatchFont32(1, ?Font_Anno) 
 EP_CatchFont16(1, ?Font_16pix) 
 EP_Create32Scroll(1, 1, 1, 430) 
 EP_SetScroll32Speed(1, 2) 



 EP_Catch3DBall(0, ?Star_Red)
 EP_Catch3DBall(4, ?Star_BChrome)
 EP_Catch3DBall(5, ?Star_Bubble)
 EP_Catch3DBall(1, ?Star_Pink)
 EP_Catch3DBall(10, ?Star_Red) 
 EP_FastRasterBar(0, RGB(255,255,255), 8) 

 EP_Init3DStarfield(1000,50,0,80,640,400)
 EP_RotateStarfieldX(0.1)
 EP_RotateStarfieldY(0.2)
 EP_RotateStarfieldZ(0.5)
 
 ; Some Jumping Rasterbars with Fast Creating
 For t = 2 To 7
   EP_FastRasterBar(t, RGB(0,15+(t*5),150+(t*15)), 16, 60,3, 400+(t*30), 2)
 Next t


EP_SetGradientTable(0  , 255, RGB(255,255,0), RGB(255,255,255))
EP_SetGradientTable(256, 500, RGB(255,255,255), RGB(255,0,255))
EP_SetGradientTable(501, 755, RGB(255,0,255), RGB(255,0,0))
EP_SetGradientTable(756, 1000,RGB(255,0,0), RGB(255,255,0))
EP_CreatePlasma(0,0,85,640,315)
EP_SetPlasma(0,145,2, 20,6, 0.5)

   FXTime    = ElapsedMilliseconds()
   Page_View = 0
   Fade_dir  = 0
   BL_SizeP.f=100.0 : BL_SizeN.f=-100.0 : BlowUP=1

Repeat
     ClearScreen(0,0,0) : EP_2DStarsDraw()
   
   
     CurrTime = ElapsedMilliseconds()
     If (CurrTime-FXTime)>10000
       EP_InitFading(RGB(0,0,0), 2, 0 , 80 , 640 , 320) : FXTime    = ElapsedMilliseconds()  : Fade_dir  = 1        
     EndIf
   
  ; The Parts 
  Select Page_View
    Case 0
      Gosub Page1
    Case 1 
      Gosub Page2
    Case 2 
      Gosub Page3
    Case 3 
      Gosub Page4 
    Case 4 
      Gosub Page5 
    Case 5 
      Gosub Page6 
    Case 6 
      Gosub Page7 
    Case 7 
      Gosub Page8       
  EndSelect

  If Page_View=8 : Page_View=0 : EndIf
  
  ; Prepare Room
  If FFad=2      
     If Page_View=2
      ; New Plasma Colors
       First_Color = RGB(Random(255),Random(255),Random(255))
       nd2_Color   = RGB(Random(255),Random(255),Random(255))
       nd3_Color   = RGB(Random(255),Random(255),Random(255))
       nd4_Color   = RGB(Random(255),Random(255),Random(255))
       EP_SetGradientTable(0  , 255, First_Color, nd2_Color)
       EP_SetGradientTable(256, 500, nd2_Color, nd3_Color)
       EP_SetGradientTable(501, 755, nd3_Color, nd4_Color)
       EP_SetGradientTable(756, 1000,nd4_Color, First_Color)
       EP_CreatePlasma(0,0,85,640,315)
       EP_SetPlasma(0,Random(200),Random(20)+0.5, Random(200),Random(20)+0.5, Random(6)+0.3 )
      EndIf
      
      
      
      Page_View+1 : Fade_dir  = 0 
   EndIf 

     
     
     EP_DisplayRasterBar(0, 80) 
     EP_DisplayRasterClone(0, 400) 
     
     DisplayTransparentSprite(10,120,0)
     For t = 2 To 7 : EP_DisplayRasterBar(t,475) : Next t
     EP_Move32Scroll(1) 


     FFad = EP_FadeScreen(Fade_dir) 
    ExamineKeyboard()
  FlipBuffers()
Until KeyboardReleased(1)



CloseScreen() 
End




Page1:
  EP_DisplayRasterBar(10, 240) : EP_DisplaySpritefield(10,1)
  EP_Text16(1, 320, 150, "Welcome to my tiny intro", 1) 
  EP_Text16(1, 320, 190, "completely written in Pure Basic", 1)
  EP_Text16(1, 320, 270, "i show you some oldskool effects" , 1) 
  EP_Text16(1, 320, 310, "for your amusement" , 1)  
Return

Page2:
  EP_DisplayRasterBar(10, 240) : EP_DisplaySpritefield(10,1)
  EP_Text16(1, 320, 200, "Fasten your seat belt a Plasma Storm", 1) 
  EP_Text16(1, 320, 250, "is coming up, with random parameters!", 1)
Return

Page3:
  EP_DisplayPlasma()
Return

Page4:
  EP_DisplayRasterBar(10, 240) : EP_DisplaySpritefield(10,1)
  EP_Text16(1, 320, 200, "Waahhouuu a UFO crossed our way", 1) 
  EP_Text16(1, 320, 250, "prepare your Laser Blaster", 1)
Return

Page5:
 EP_RotateStarfieldX(0) : EP_RotateStarfieldY(0) : EP_RotateStarfieldZ(0)  
  EP_DisplayStarfield() 
  Start3D() : EP_DrawBallObject() : Stop3D()
Return

Page6:
  EP_RotateStarfieldX(0.1) : EP_RotateStarfieldY(0.2) : EP_RotateStarfieldZ(0.5)
  EP_DisplayRasterBar(10, 240) : EP_DisplaySpritefield(10,1)
  EP_Text16(1, 320, 200, "Arrgs a Glenz Vector thing", 1) 
  EP_Text16(1, 320, 250, "Durability date exceeded ?!!", 1)
Return

Page7:
 EP_RotateStarfieldX(0) : EP_RotateStarfieldY(0) : EP_RotateStarfieldZ(0)
 EP_DisplayStarfield() 
  
  If BlowUP=1 
    BL_SizeP.f + 0.9 : BL_SizeN.f - 0.9        
 EndIf
 
  If BlowUP=0 
    BL_SizeP.f - 0.9 : BL_SizeN.f + 0.9      
 EndIf
 
 If BL_SizeP>250 : BlowUP=0 : EndIf
 If BL_SizeP<10  : BlowUP=1 : EndIf
 
    ; New Positions for some Vector Points
    

    EP_SetVectorPoint(8,0,0,BL_SizeN)
    EP_SetVectorPoint(9,0,0,BL_SizeP)
    EP_SetVectorPoint(10,BL_SizeN,0,0)
    EP_SetVectorPoint(11,BL_SizeP,0, 0)
    EP_SetVectorPoint(12,0,BL_SizeN,0)
    EP_SetVectorPoint(13,0,BL_SizeP,0) 

  Start3D()

      EP_DrawVectorObject()
  Stop3D()
Return

Page8:
  EP_RotateStarfieldX(0.1) : EP_RotateStarfieldY(0.2) : EP_RotateStarfieldZ(0.5)
  EP_DisplayRasterBar(10, 240) : EP_DisplaySpritefield(10,1)
  EP_Text16(1, 320, 150, "Thats all my Friend, all the Stuff", 1) 
  EP_Text16(1, 320, 190, "written using Pure Basic and my FX-Lib", 1)
  EP_Text16(1, 320, 230, "Music was composed by Quazar of Sanxion", 1)
  EP_Text16(1, 320, 270, "Come and get your copy on Pure Area" , 1) 
  EP_Text16(1, 320, 310, "we repeat the show now !!!" , 1)  
Return



DataSection 

Pic_Pure:  IncludeBinary "Logos/Pure_pic.png"
Pic_Basic: IncludeBinary "Logos/Basic_pic.png"
Pic_Ship:  IncludeBinary "Bobs/Ship_pic.png"
Pic_Blob:  IncludeBinary "Bobs/Blob_pic.png"
Font_Hole: IncludeBinary "Fonts/Font 32 - theHole.png"
Font_Anno: IncludeBinary "Fonts/pix32annonce2.bmp"
Font_16pix:IncludeBinary "Fonts/Font 16 - Hot Metall.png"

Star_Red:    IncludeBinary "Bobs/Bob64_RedChrome.png"
Star_Bubble: IncludeBinary "Bobs/Bob64_Bubble.png"
Star_BChrome:IncludeBinary "Bobs/Bob64_BlueChrome.png"
Star_Pink:   IncludeBinary "Bobs/Bob64_PinkPlastik.png"



Pic_Logo:  IncludeBinary "Logos/PB Logo3.png"

UFO1: 
IncludeBinary("objects/UFO.obj")
UFO2:

 mod:
  IncludeBinary "sfx/quazar-funky_stars.xm"
 modend:
 
Cube1: 
IncludeBinary("Objects/Cube2.vobj")
Cube2:
  
EndDataSection 
; IDE Options = PureBasic v3.94 (Windows - x86)
; DisableDebugger