;#*************************************************************#
;*                                                             *
;*          Plasma Example by Epyx / Epyx_FXLib v1.1           *
;*                                                             *
;#*************************************************************#
InitSprite()
InitSprite3D()
InitKeyboard()
EP_InitFXLib()


OpenScreen(640,480,32,"Plasma Effekt - Epyx FXLib")


; Create a fine color gradient, for plasma use all 1001 color slots
; Plasma uses ever 1001 different colors empty slots are Black
EP_SetGradientTable(0  , 255, RGB(255,255,0), RGB(255,255,255))
EP_SetGradientTable(256, 500, RGB(255,255,255), RGB(255,0,255))
EP_SetGradientTable(501, 755, RGB(255,0,255), RGB(255,0,0))
EP_SetGradientTable(756, 1000,RGB(255,0,0), RGB(255,255,0))

; Load a tine 8 pix font to show you FPS
EP_CatchFont8(0,?font)

; Create the Plasma Screen
EP_CreatePlasma(0,0,100,640,300)

; Put some sinus values
EP_SetPlasma(0,145,2, 20,6, 0.5)


Repeat
  ClearScreen(0,0,20)

  ; show the cool plasma
  EP_DisplayPlasma()


  ; FPS and some Text
  EP_Text8(0,637,10,"FPS: "+Str(EP_FPS()),2)
  EP_Text8(0,0,10,"FlipBuffer "+Str(Buffer_Switch),0)
  

  FlipBuffers(Buffer_Switch)
  ExamineKeyboard()
  If KeyboardReleased(#PB_Key_F1) : Buffer_Switch+1 : If Buffer_Switch=2 : Buffer_Switch=0 : EndIf : EndIf
Until KeyboardReleased(1)



EP_ClosePlasma()
CloseScreen() 
End


font: IncludeBinary "Fonts/pix8 Goldfont.bmp"
; IDE Options = PureBasic v3.94 (Windows - x86)
; Executable = Plasma.exe