;#*************************************************************#
;*                                                             *
;*            Vector Intro by Epyx / Epyx_FXLib v1.2           *
;*                                                             *
;#*************************************************************#

InitSprite()
InitKeyboard()
InitSprite3D()
EP_InitFXLib()

OpenScreen(640,480,32,"Vector Intro - Epyx FXLib")
UsePNGImageDecoder()



x= EP_CatchVectorObject(?Obj1, ?Obj2)



EP_InitVectorShade() ; Enable Shading 4 our Vectors


; Let em Rotate
 EP_SetVectorXRotation(2)
 EP_SetVectorYRotation(-1)
 EP_SetVectorZRotation(-1)

; and Fly around
EP_SetVectorYFly(120,-1.8)
EP_SetVectorXFly(300, 1.9)
EP_SetVectorZFly(200, 1.4)

CatchSprite(1, ?Logo) ; Catch the Logo



Start = ElapsedMilliseconds()


; Some Jumping Rasterbars with Fast Creating
 For t = 2 To 7
   EP_FastRasterBar(t, RGB(150+(t*15),15+(t*15),0), 32, 200,2, 400+(t*20), 2)
 Next t

MachSchluss=0
Objekt = 1

Repeat

getz = ElapsedMilliseconds()
If MachSchluss=0
If (getz-Start)>10000 : MachSchluss=1 :   YPosi=EP_GetVectorYPos() : EndIf
EndIf

  ClearScreen(0,0,0)
  DisplaySprite(1,0,50)
  
  ; Now display the Moving Bars
  For t = 2 To 7 : EP_DisplayRasterBar(t,460) : Next t

  If MachSchluss=1 : EP_SetVectorYFly(0, 0) : YPosi + 1 : EndIf
  EP_SetVectorYPos(YPosi) ; Set Y Position of the Object

  If YPosi>600
     ; New object please
     If Objekt = 0 : EP_CatchVectorObject(?Obj1, ?Obj2) : EndIf
     If Objekt = 1 : EP_CatchVectorObject(?Obj3, ?Obj4) : EndIf
     
     Objekt+1 : If Objekt=2 : Objekt=0 : EndIf
     MachSchluss=2
     EP_SetVectorYPos(YPosi) 
  EndIf
  
  If MachSchluss=2 : YPosi - 1
  If YPosi<0 :  MachSchluss=0 : Start = ElapsedMilliseconds() : EndIf
  EndIf
  



  Start3D()
     ; Display the Vector Object
     EP_DrawVectorObject()
  Stop3D()

 
  FlipBuffers()
  ExamineKeyboard()
Until KeyboardReleased(1)


CloseScreen() 
End

Obj1: 
IncludeBinary("objects/Flie.vobj")
Obj2:

Logo:IncludeBinary("Logos/PB Logo.png")

Obj3: 
IncludeBinary("objects/Glenz-Cube.vobj")
Obj4:
; IDE Options = PureBasic v3.94 (Windows - x86)
; DisableDebugger