  Structure MEMFILE
    Length.l
    pos.l
    mdata.l
  EndStructure
    
  Procedure.l modopenmem(*memfile.MEMFILE)
    *memfile = AllocateMemory(SizeOf(MEMFILE))
    *memfile\mdata = ?mod
    *memfile\Length = ?modend - ?mod
    *memfile\pos    = 0
    
    ProcedureReturn *memfile
  EndProcedure
    
  Procedure.l modclosemem(*memfile.MEMFILE)
    FreeMemory(*memfile) : *memfile = #Null
  EndProcedure
    
  Procedure.l modreadmem(Buffer.l, size.l, *memfile.MEMFILE)
    If *memfile\pos + size >= *memfile\Length
      size = *memfile\Length - *memfile\pos
    EndIf
    
    CopyMemory(*memfile\mdata+*memfile\pos, Buffer, size)
    
    *memfile\pos + size  ; update filepointer position
    ProcedureReturn size
  EndProcedure
    
  Procedure modseekmem(*memfile.MEMFILE, pos.l, mode.l) 
    Select mode
      Case #SEEK_SET
        *memfile\pos = pos
      Case #SEEK_CUR
        *memfile\pos+pos
    EndSelect
    
    If *memfile\pos > *memfile\Length
      *memfile\pos = *memfile\Length
    EndIf
  EndProcedure
    
  Procedure.l modtellmem(*memfile.MEMFILE)
    ProcedureReturn *memfile\pos
  EndProcedure


  FSOUND_File_SetCallbacks(@modopenmem(), @modclosemem(), @modreadmem(), @modseekmem(), @modtellmem())
  mod = FMUSIC_LoadSong("", #Null)


  
 
; IDE Options = PureBasic v3.94 (Windows - x86)